<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleMocoInverse.m</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleMocoInverse_8m-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleMocoInverse.m</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example using the MocoInverse tool with a complex model to prescribe walking. This example also shows how to track electromyography data.</p>
<div class="fragment"><div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% <a class="code" href="namespaceOpenSim.html">OpenSim</a> Moco: exampleMocoInverse.m                                         %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% Copyright (c) 2020 Stanford University and the Authors                     %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Author(s): Christopher Dembia                                              %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    %</div>
<div class="line">% not use <span class="keyword">this</span> file except in compliance with the License. You may obtain a  %</div>
<div class="line">% copy of the License at http:<span class="comment">//www.apache.org/licenses/LICENSE-2.0          %</span></div>
<div class="line">%                                                                            %</div>
<div class="line">% Unless required by applicable law or agreed to in writing, software        %</div>
<div class="line">% distributed under the License is distributed on an <span class="stringliteral">&quot;AS IS&quot;</span> BASIS,          %</div>
<div class="line">% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   %</div>
<div class="line">% See the License <span class="keywordflow">for</span> the specific language governing permissions and        %</div>
<div class="line">% limitations under the License.                                             %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line"> </div>
<div class="line">% This example shows how to use the MocoInverse tool to exactly prescribe a</div>
<div class="line">% motion and estimate muscle behavior for walking. The first example does not</div>
<div class="line">% rely on electromyography data, while the second example penalizes deviation</div>
<div class="line">% from electromyography data for a subset of muscles.</div>
<div class="line">%</div>
<div class="line">% See the README.txt next to this file for more information.</div>
<div class="line"> </div>
<div class="line">function exampleMocoInverse()</div>
<div class="line"> </div>
<div class="line">% This problem solves in about 5 minutes.</div>
<div class="line">solveMocoInverse();</div>
<div class="line"> </div>
<div class="line">% This problem penalizes the deviation from electromyography data <span class="keywordflow">for</span> a</div>
<div class="line">% subset of muscles, and solves in about 30 minutes.</div>
<div class="line">solveMocoInverseWithEMG();</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line"><span class="keyword">function</span> solveMocoInverse()</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">% Construct the MocoInverse tool.</div>
<div class="line">inverse = MocoInverse();</div>
<div class="line"> </div>
<div class="line">% Construct a ModelProcessor and set it on the tool. The default</div>
<div class="line">% muscles in the model are replaced with optimization-friendly</div>
<div class="line">% DeGrooteFregly2016Muscles, and adjustments are made to the default muscle</div>
<div class="line">% parameters.</div>
<div class="line">modelProcessor = ModelProcessor(&#39;subject_walk_armless.osim&#39;);</div>
<div class="line">modelProcessor.append(ModOpAddExternalLoads(&#39;grf_walk.xml&#39;));</div>
<div class="line">modelProcessor.append(ModOpIgnoreTendonCompliance());</div>
<div class="line">modelProcessor.append(ModOpReplaceMusclesWithDeGrooteFregly2016());</div>
<div class="line">% Only valid for DeGrooteFregly2016Muscles.</div>
<div class="line">modelProcessor.append(ModOpIgnorePassiveFiberForcesDGF());</div>
<div class="line">% Only valid for DeGrooteFregly2016Muscles.</div>
<div class="line">modelProcessor.append(ModOpScaleActiveFiberForceCurveWidthDGF(1.5));</div>
<div class="line">modelProcessor.append(ModOpAddReserves(1.0));</div>
<div class="line">inverse.setModel(modelProcessor);</div>
<div class="line"> </div>
<div class="line">% Construct a TableProcessor of the coordinate data and pass it to the</div>
<div class="line">% inverse tool. TableProcessors can be used in the same way as</div>
<div class="line">% ModelProcessors by appending TableOperators to modify the base table.</div>
<div class="line">% A TableProcessor with no operators, as we have here, simply returns the</div>
<div class="line">% base table.</div>
<div class="line">inverse.setKinematics(TableProcessor(&#39;coordinates.sto&#39;));</div>
<div class="line"> </div>
<div class="line">% Initial time, final time, and mesh interval.</div>
<div class="line">inverse.set_initial_time(0.81);</div>
<div class="line">inverse.set_final_time(1.79);</div>
<div class="line">inverse.set_mesh_interval(0.02);</div>
<div class="line"> </div>
<div class="line">% By default, Moco gives an error if the kinematics contains extra columns.</div>
<div class="line">% Here, we tell Moco to allow (and ignore) those extra columns.</div>
<div class="line">inverse.set_kinematics_allow_extra_columns(true);</div>
<div class="line"> </div>
<div class="line">% Solve the problem and write the solution to a Storage file.</div>
<div class="line">solution = inverse.solve();</div>
<div class="line">solution.getMocoSolution().write(&#39;example3DWalking_MocoInverse_solution.sto&#39;);</div>
<div class="line"> </div>
<div class="line">% Generate a report with plots for the solution trajectory.</div>
<div class="line">model = modelProcessor.process();</div>
<div class="line">report = osimMocoTrajectoryReport(model, ...</div>
<div class="line">        &#39;example3DWalking_MocoInverse_solution.sto&#39;, &#39;bilateral&#39;, true);</div>
<div class="line">% The report is saved to the working directory.</div>
<div class="line">reportFilepath = report.generate();</div>
<div class="line">open(reportFilepath);</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">function solveMocoInverseWithEMG()</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">% This initial block of code is identical to the code above.</div>
<div class="line">inverse = MocoInverse();</div>
<div class="line">modelProcessor = ModelProcessor(&#39;subject_walk_armless.osim&#39;);</div>
<div class="line">modelProcessor.append(ModOpAddExternalLoads(&#39;grf_walk.xml&#39;));</div>
<div class="line">modelProcessor.append(ModOpIgnoreTendonCompliance());</div>
<div class="line">modelProcessor.append(ModOpReplaceMusclesWithDeGrooteFregly2016());</div>
<div class="line">modelProcessor.append(ModOpIgnorePassiveFiberForcesDGF());</div>
<div class="line">modelProcessor.append(ModOpScaleActiveFiberForceCurveWidthDGF(1.5));</div>
<div class="line">modelProcessor.append(ModOpAddReserves(1.0));</div>
<div class="line">inverse.setModel(modelProcessor);</div>
<div class="line">inverse.setKinematics(TableProcessor(&#39;coordinates.sto&#39;));</div>
<div class="line">inverse.set_initial_time(0.81);</div>
<div class="line">inverse.set_final_time(1.79);</div>
<div class="line">inverse.set_mesh_interval(0.02);</div>
<div class="line">inverse.set_kinematics_allow_extra_columns(true);</div>
<div class="line"> </div>
<div class="line">study = inverse.initialize();</div>
<div class="line">problem = study.updProblem();</div>
<div class="line"> </div>
<div class="line">% Add electromyography tracking.</div>
<div class="line">emgTracking = MocoControlTrackingGoal(&#39;emg_tracking&#39;);</div>
<div class="line">emgTracking.setWeight(50.0);</div>
<div class="line">% Each column in electromyography.sto is normalized so the maximum value in</div>
<div class="line">% each column is 1.0.</div>
<div class="line">controlsRef = TimeSeriesTable(&#39;electromyography.sto&#39;);</div>
<div class="line"> </div>
<div class="line">% Scale down the tracked muscle activity based on peak levels from</div>
<div class="line">% &quot;Gait Analysis: Normal and Pathological Function&quot; by</div>
<div class="line">% Perry and Burnfield, 2010 (digitized by Carmichael Ong).</div>
<div class="line">soleus = controlsRef.updDependentColumn(&#39;soleus&#39;);</div>
<div class="line">gasmed = controlsRef.updDependentColumn(&#39;gastrocnemius&#39;);</div>
<div class="line">tibant = controlsRef.updDependentColumn(&#39;tibialis_anterior&#39;);</div>
<div class="line">for t = 0:controlsRef.getNumRows() - 1</div>
<div class="line">    soleus.set(t, 0.77 * soleus.get(t));</div>
<div class="line">    gasmed.set(t, 0.87 * gasmed.get(t));</div>
<div class="line">    tibant.set(t, 0.37 * tibant.get(t));</div>
<div class="line">end</div>
<div class="line">emgTracking.setReference(TableProcessor(controlsRef));</div>
<div class="line">% Associate actuators in the model with columns in electromyography.sto.</div>
<div class="line">emgTracking.setReferenceLabel(&#39;/forceset/soleus_r&#39;, &#39;soleus&#39;)</div>
<div class="line">emgTracking.setReferenceLabel(&#39;/forceset/gasmed_r&#39;, &#39;gastrocnemius&#39;)</div>
<div class="line">emgTracking.setReferenceLabel(&#39;/forceset/gaslat_r&#39;, &#39;gastrocnemius&#39;)</div>
<div class="line">emgTracking.setReferenceLabel(&#39;/forceset/tibant_r&#39;, &#39;tibialis_anterior&#39;)</div>
<div class="line">problem.addGoal(emgTracking)</div>
<div class="line"> </div>
<div class="line">% Solve the problem and write the solution to a Storage file.</div>
<div class="line">solution = study.solve();</div>
<div class="line">solution.write(&#39;example3DWalking_MocoInverseWithEMG_solution.sto&#39;);</div>
<div class="line"> </div>
<div class="line">% Write the reference data in a way that&#39;s easy to compare to the solution.</div>
<div class="line">controlsRef.removeColumn(&#39;medial_hamstrings&#39;);</div>
<div class="line">controlsRef.removeColumn(&#39;biceps_femoris&#39;);</div>
<div class="line">controlsRef.removeColumn(&#39;vastus_lateralis&#39;);</div>
<div class="line">controlsRef.removeColumn(&#39;vastus_medius&#39;);</div>
<div class="line">controlsRef.removeColumn(&#39;rectus_femoris&#39;);</div>
<div class="line">controlsRef.removeColumn(&#39;gluteus_maximus&#39;);</div>
<div class="line">controlsRef.removeColumn(&#39;gluteus_medius&#39;);</div>
<div class="line">columnLabels = StdVectorString();</div>
<div class="line">columnLabels.add(&#39;/forceset/soleus_r&#39;);</div>
<div class="line">columnLabels.add(&#39;/forceset/gasmed_r&#39;);</div>
<div class="line">columnLabels.add(&#39;/forceset/tibant_r&#39;);</div>
<div class="line">controlsRef.setColumnLabels(columnLabels);</div>
<div class="line">controlsRef.appendColumn(&#39;/forceset/gaslat_r&#39;, gasmed);</div>
<div class="line">STOFileAdapter.write(controlsRef, &#39;controls_reference.sto&#39;);</div>
<div class="line"> </div>
<div class="line">% Generate a report comparing MocoInverse solutions without and with EMG</div>
<div class="line">% tracking.</div>
<div class="line">model = modelProcessor.process();</div>
<div class="line">report = osimMocoTrajectoryReport(model, ...</div>
<div class="line">        &#39;example3DWalking_MocoInverse_solution.sto&#39;, ...</div>
<div class="line">        &#39;outputFilepath&#39;, &#39;example3DWalking_MocoInverseWithEMG_report.pdf&#39;, ...</div>
<div class="line">        &#39;bilateral&#39;, true, ...</div>
<div class="line">        &#39;refFiles&#39;, {<span class="stringliteral">&#39;example3DWalking_MocoInverseWithEMG_solution.sto&#39;</span>, ...</div>
<div class="line">                     <span class="stringliteral">&#39;controls_reference.sto&#39;</span>});</div>
<div class="line">% The report is saved to the working directory.</div>
<div class="line">reportFilepath = report.generate();</div>
<div class="line">open(reportFilepath);</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:39 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
